package com.perforce.hws.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

/**
 * A background thread used to read input from processes we're executing and waiting on.
 */
public class StreamReaderThread extends Thread {

    private InputStream is;

    private StringBuffer stringBuffer;

    private IOException exception;

    public StreamReaderThread(InputStream is) {
        this.is = is;
        stringBuffer = new StringBuffer();
        exception = null;
    }

    public StringBuffer getStringBuffer() {
        return stringBuffer;
    }

    public IOException getException() {
        return exception;
    }

    @Override
    public void run() {
        try {
            InputStreamReader isr = new InputStreamReader(is);
            BufferedReader br = new BufferedReader(isr);
            String line;
            while ((line = br.readLine()) != null) {
                stringBuffer.append(line).append("\n");
            }
        } catch (IOException e) {
            exception = e;
        }
    }
}
