package com.perforce.hws.util;

import java.util.function.BooleanSupplier;

/**
 * Helper methods related to synchronizing multiple (external) processes or threads.
 */
public interface TimingHelpers {

    default boolean waitFor(int retries, int sleep, BooleanSupplier booleanSupplier) {
        try {
            while (0 < retries && !booleanSupplier.getAsBoolean()) {
                Thread.sleep(sleep);
                retries--;
            }
            return booleanSupplier.getAsBoolean();
        } catch (InterruptedException interrupt) {
            throw new RuntimeException(interrupt);
        }
    }
}
